"""
    Adobe Experience Manager OSGI config (AEM) API

    Swagger AEM OSGI is an OpenAPI specification for Adobe Experience Manager (AEM) OSGI Configurations API  # noqa: E501

    The version of the OpenAPI document: 1.0.0-pre.0
    Contact: opensource@shinesolutions.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

import nulltype  # noqa: F401

from swaggeraemosgi.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)

def lazy_import():
    from swaggeraemosgi.model.config_node_property_array import ConfigNodePropertyArray
    from swaggeraemosgi.model.config_node_property_boolean import ConfigNodePropertyBoolean
    from swaggeraemosgi.model.config_node_property_drop_down import ConfigNodePropertyDropDown
    from swaggeraemosgi.model.config_node_property_float import ConfigNodePropertyFloat
    from swaggeraemosgi.model.config_node_property_integer import ConfigNodePropertyInteger
    from swaggeraemosgi.model.config_node_property_string import ConfigNodePropertyString
    globals()['ConfigNodePropertyArray'] = ConfigNodePropertyArray
    globals()['ConfigNodePropertyBoolean'] = ConfigNodePropertyBoolean
    globals()['ConfigNodePropertyDropDown'] = ConfigNodePropertyDropDown
    globals()['ConfigNodePropertyFloat'] = ConfigNodePropertyFloat
    globals()['ConfigNodePropertyInteger'] = ConfigNodePropertyInteger
    globals()['ConfigNodePropertyString'] = ConfigNodePropertyString


class ComAdobeCqScreensMqActivemqImplArtemisJMSProviderProperties(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'service_ranking': (ConfigNodePropertyInteger,),  # noqa: E501
            'global_size': (ConfigNodePropertyInteger,),  # noqa: E501
            'max_disk_usage': (ConfigNodePropertyInteger,),  # noqa: E501
            'persistence_enabled': (ConfigNodePropertyBoolean,),  # noqa: E501
            'thread_pool_max_size': (ConfigNodePropertyInteger,),  # noqa: E501
            'scheduled_thread_pool_max_size': (ConfigNodePropertyInteger,),  # noqa: E501
            'graceful_shutdown_timeout': (ConfigNodePropertyInteger,),  # noqa: E501
            'queues': (ConfigNodePropertyArray,),  # noqa: E501
            'topics': (ConfigNodePropertyArray,),  # noqa: E501
            'addresses_max_delivery_attempts': (ConfigNodePropertyInteger,),  # noqa: E501
            'addresses_expiry_delay': (ConfigNodePropertyInteger,),  # noqa: E501
            'addresses_address_full_message_policy': (ConfigNodePropertyDropDown,),  # noqa: E501
            'addresses_max_size_bytes': (ConfigNodePropertyInteger,),  # noqa: E501
            'addresses_page_size_bytes': (ConfigNodePropertyInteger,),  # noqa: E501
            'addresses_page_cache_max_size': (ConfigNodePropertyInteger,),  # noqa: E501
            'cluster_user': (ConfigNodePropertyString,),  # noqa: E501
            'cluster_password': (ConfigNodePropertyString,),  # noqa: E501
            'cluster_call_timeout': (ConfigNodePropertyInteger,),  # noqa: E501
            'cluster_call_failover_timeout': (ConfigNodePropertyInteger,),  # noqa: E501
            'cluster_client_failure_check_period': (ConfigNodePropertyInteger,),  # noqa: E501
            'cluster_notification_attempts': (ConfigNodePropertyInteger,),  # noqa: E501
            'cluster_notification_interval': (ConfigNodePropertyInteger,),  # noqa: E501
            'id_cache_size': (ConfigNodePropertyInteger,),  # noqa: E501
            'cluster_confirmation_window_size': (ConfigNodePropertyInteger,),  # noqa: E501
            'cluster_connection_ttl': (ConfigNodePropertyInteger,),  # noqa: E501
            'cluster_duplicate_detection': (ConfigNodePropertyBoolean,),  # noqa: E501
            'cluster_initial_connect_attempts': (ConfigNodePropertyInteger,),  # noqa: E501
            'cluster_max_retry_interval': (ConfigNodePropertyInteger,),  # noqa: E501
            'cluster_min_large_message_size': (ConfigNodePropertyInteger,),  # noqa: E501
            'cluster_producer_window_size': (ConfigNodePropertyInteger,),  # noqa: E501
            'cluster_reconnect_attempts': (ConfigNodePropertyInteger,),  # noqa: E501
            'cluster_retry_interval': (ConfigNodePropertyInteger,),  # noqa: E501
            'cluster_retry_interval_multiplier': (ConfigNodePropertyFloat,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'service_ranking': 'service.ranking',  # noqa: E501
        'global_size': 'global.size',  # noqa: E501
        'max_disk_usage': 'max.disk.usage',  # noqa: E501
        'persistence_enabled': 'persistence.enabled',  # noqa: E501
        'thread_pool_max_size': 'thread.pool.max.size',  # noqa: E501
        'scheduled_thread_pool_max_size': 'scheduled.thread.pool.max.size',  # noqa: E501
        'graceful_shutdown_timeout': 'graceful.shutdown.timeout',  # noqa: E501
        'queues': 'queues',  # noqa: E501
        'topics': 'topics',  # noqa: E501
        'addresses_max_delivery_attempts': 'addresses.max.delivery.attempts',  # noqa: E501
        'addresses_expiry_delay': 'addresses.expiry.delay',  # noqa: E501
        'addresses_address_full_message_policy': 'addresses.address.full.message.policy',  # noqa: E501
        'addresses_max_size_bytes': 'addresses.max.size.bytes',  # noqa: E501
        'addresses_page_size_bytes': 'addresses.page.size.bytes',  # noqa: E501
        'addresses_page_cache_max_size': 'addresses.page.cache.max.size',  # noqa: E501
        'cluster_user': 'cluster.user',  # noqa: E501
        'cluster_password': 'cluster.password',  # noqa: E501
        'cluster_call_timeout': 'cluster.call.timeout',  # noqa: E501
        'cluster_call_failover_timeout': 'cluster.call.failover.timeout',  # noqa: E501
        'cluster_client_failure_check_period': 'cluster.client.failure.check.period',  # noqa: E501
        'cluster_notification_attempts': 'cluster.notification.attempts',  # noqa: E501
        'cluster_notification_interval': 'cluster.notification.interval',  # noqa: E501
        'id_cache_size': 'id.cache.size',  # noqa: E501
        'cluster_confirmation_window_size': 'cluster.confirmation.window.size',  # noqa: E501
        'cluster_connection_ttl': 'cluster.connection.ttl',  # noqa: E501
        'cluster_duplicate_detection': 'cluster.duplicate.detection',  # noqa: E501
        'cluster_initial_connect_attempts': 'cluster.initial.connect.attempts',  # noqa: E501
        'cluster_max_retry_interval': 'cluster.max.retry.interval',  # noqa: E501
        'cluster_min_large_message_size': 'cluster.min.large.message.size',  # noqa: E501
        'cluster_producer_window_size': 'cluster.producer.window.size',  # noqa: E501
        'cluster_reconnect_attempts': 'cluster.reconnect.attempts',  # noqa: E501
        'cluster_retry_interval': 'cluster.retry.interval',  # noqa: E501
        'cluster_retry_interval_multiplier': 'cluster.retry.interval.multiplier',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """ComAdobeCqScreensMqActivemqImplArtemisJMSProviderProperties - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            service_ranking (ConfigNodePropertyInteger): [optional]  # noqa: E501
            global_size (ConfigNodePropertyInteger): [optional]  # noqa: E501
            max_disk_usage (ConfigNodePropertyInteger): [optional]  # noqa: E501
            persistence_enabled (ConfigNodePropertyBoolean): [optional]  # noqa: E501
            thread_pool_max_size (ConfigNodePropertyInteger): [optional]  # noqa: E501
            scheduled_thread_pool_max_size (ConfigNodePropertyInteger): [optional]  # noqa: E501
            graceful_shutdown_timeout (ConfigNodePropertyInteger): [optional]  # noqa: E501
            queues (ConfigNodePropertyArray): [optional]  # noqa: E501
            topics (ConfigNodePropertyArray): [optional]  # noqa: E501
            addresses_max_delivery_attempts (ConfigNodePropertyInteger): [optional]  # noqa: E501
            addresses_expiry_delay (ConfigNodePropertyInteger): [optional]  # noqa: E501
            addresses_address_full_message_policy (ConfigNodePropertyDropDown): [optional]  # noqa: E501
            addresses_max_size_bytes (ConfigNodePropertyInteger): [optional]  # noqa: E501
            addresses_page_size_bytes (ConfigNodePropertyInteger): [optional]  # noqa: E501
            addresses_page_cache_max_size (ConfigNodePropertyInteger): [optional]  # noqa: E501
            cluster_user (ConfigNodePropertyString): [optional]  # noqa: E501
            cluster_password (ConfigNodePropertyString): [optional]  # noqa: E501
            cluster_call_timeout (ConfigNodePropertyInteger): [optional]  # noqa: E501
            cluster_call_failover_timeout (ConfigNodePropertyInteger): [optional]  # noqa: E501
            cluster_client_failure_check_period (ConfigNodePropertyInteger): [optional]  # noqa: E501
            cluster_notification_attempts (ConfigNodePropertyInteger): [optional]  # noqa: E501
            cluster_notification_interval (ConfigNodePropertyInteger): [optional]  # noqa: E501
            id_cache_size (ConfigNodePropertyInteger): [optional]  # noqa: E501
            cluster_confirmation_window_size (ConfigNodePropertyInteger): [optional]  # noqa: E501
            cluster_connection_ttl (ConfigNodePropertyInteger): [optional]  # noqa: E501
            cluster_duplicate_detection (ConfigNodePropertyBoolean): [optional]  # noqa: E501
            cluster_initial_connect_attempts (ConfigNodePropertyInteger): [optional]  # noqa: E501
            cluster_max_retry_interval (ConfigNodePropertyInteger): [optional]  # noqa: E501
            cluster_min_large_message_size (ConfigNodePropertyInteger): [optional]  # noqa: E501
            cluster_producer_window_size (ConfigNodePropertyInteger): [optional]  # noqa: E501
            cluster_reconnect_attempts (ConfigNodePropertyInteger): [optional]  # noqa: E501
            cluster_retry_interval (ConfigNodePropertyInteger): [optional]  # noqa: E501
            cluster_retry_interval_multiplier (ConfigNodePropertyFloat): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
